#include "chdecl.h"
void CH_type_recheckclass(current, sched, cop)
#define ARGUMENTS 9
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto cb4;
    case 4: goto c5;
    case 5: goto c13;
    case 6: goto c16;
    case 7: goto c19;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* new_table 4 , 2 */
  if ((ch_returncode = che_new_table(DEF(4),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
  current->ip = 3;
cb4:
/* call 3.3 3.0.0 3.0.1 3.1 4 3.2 3.0.2 , 3 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(3),
          arguments[1] = DEF(3)DOT(0)DOT(0),
          arguments[2] = DEF(3)DOT(0)DOT(1),
          arguments[3] = DEF(3)DOT(1),
          arguments[4] = DEF(4),
          arguments[5] = DEF(3)DOT(2),
          arguments[6] = DEF(3)DOT(0)DOT(2),
          arguments[6+1] = nil,& arguments[0]),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* size 5 4 */
  REF(5).value.integer = REF(4).value.table->size;
  REF(5).tsdr = & dr_integer;
/* equal . 5 =(0) , 10 */
  if ( REF(5).value.integer == 0 ) goto c10;
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c10:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 16 */
   goto c16;
c13:
/* chs_lit 6 , "RecheckClass created a backpatch entry?" */
  if( !chs_lit(DEF(6),"RecheckClass created a backpatch entry?") )
     goto ch_depletion;
/* print 6 */
  re_print(stderr, 0, DEF(6)); fflush(stderr);
/* discard 6 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).tsdr = & dr_bottom;
c16:
/* discard 3 */
  (*(REF(3).tsdr)->finalize)(REF(3).value,F_DISCARD,sched);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c19:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
